#ifndef EFL_GENERATED_EVAS_3D_OBJECT_HH
#define EFL_GENERATED_EVAS_3D_OBJECT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_object.eo.h"
}

#include "evas_common_interface.eo.hh"

struct evas_3d_object
      : efl::eo::base,
      efl::eo::detail::extension_inheritance<evas::common_interface>::template type< ::evas_3d_object>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_object(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_object(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   evas_3d_object(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_3d_object(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_object(evas_3d_object const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_object() {}

   /// @brief No description supplied by the EAPI.
   ///
   /// @param ret 
   ///
   Evas * evas_get() const
   {
      Evas * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_common_evas_get());
      return _tmp_ret;
   }

   /// @brief Notify the object regarding its  state change.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change(Evas_3D_State state_, Evas_3D_Object * ref_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_change(state_, ref_));
   }

   /// @brief Returns the type of the object.
   ///
   Evas_3D_Object_Type type_get() const
   {
      Evas_3D_Object_Type _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_object_type_get());
      return _tmp_ret;
   }

   /// @brief Returns the type of the object.
   ///
   /// @param type 
   ///
   void type_set(Evas_3D_Object_Type type_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_type_set(type_));
   }

   /// @brief Returns the status of a particular state of the object.
   ///
   /// @param state State whose status is being asked
   ///
   bool dirty_get(Evas_3D_State state_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_object_dirty_get(state_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Update request for the object.
   ///
   void update() const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_update());
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_OBJECT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_3D_OBJECT_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Evas * _evas_3d_object_evas_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->evas_get();
}

template <typename T>
void _evas_3d_object_change_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   static_cast<T*>(self->this_)->change(state_, ref_);
}

template <typename T>
Evas_3D_Object_Type _evas_3d_object_type_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->type_get();
}

template <typename T>
void _evas_3d_object_type_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Object_Type type_)
{
   static_cast<T*>(self->this_)->type_set(type_);
}

template <typename T>
bool _evas_3d_object_dirty_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_)
{
   return static_cast<T*>(self->this_)->dirty_get(state_);
}

template <typename T>
void _evas_3d_object_update_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->update();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_object >
{
   template <typename T>
   struct type
   {
      virtual Evas * evas_get()
      {
         Evas * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_common_evas_get());
            return _tmp_ret;
      }

      virtual void change(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change(state_, ref_));
      }

      virtual Evas_3D_Object_Type type_get()
      {
         Evas_3D_Object_Type _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_object_type_get());
            return _tmp_ret;
      }

      virtual void type_set(Evas_3D_Object_Type type_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_type_set(type_));
      }

      virtual bool dirty_get(Evas_3D_State state_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_object_dirty_get(state_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void update()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update());
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_object >
{
   static const int value = 6;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_3d_object>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_object_evas_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_common_evas_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_object_change_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_object_type_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_object_type_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_object_type_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_object_type_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_object_dirty_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_object_dirty_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_object_update_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::evas_3d_object >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_object, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::evas_3d_object >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_object, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::evas_3d_object>
{
   template <typename U>
   struct type
   {
      operator ::evas_3d_object() const
      {
         return ::evas_3d_object(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Evas * evas_get()
      {
         Evas * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_common_evas_get());
            return _tmp_ret;
      }

      void change(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_change(state_, ref_));
      }

      Evas_3D_Object_Type type_get()
      {
         Evas_3D_Object_Type _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_object_type_get());
            return _tmp_ret;
      }

      void type_set(Evas_3D_Object_Type type_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_type_set(type_));
      }

      bool dirty_get(Evas_3D_State state_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_object_dirty_get(state_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void update()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_update());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_3d_object>)
{
   return (EVAS_3D_OBJECT_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_OBJECT_HH

